Package org.apache.any23.extractor

## Interface ExtractorRegistry

-     public interface ExtractorRegistry

  An interface to the enable a registry for extractors to be implemented by different implementors of this API.
  Author:
    Peter Ansell p_ansell@yahoo.com

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `List<String>` | `getAllNames()` | Returns the names of all registered extractors, sorted alphabetically.
    `ExtractorGroup` | `getExtractorGroup()` |
    `ExtractorGroup` | `getExtractorGroup​(List<String> names)` | Returns an `ExtractorGroup` containing the `ExtractorFactory` mathing the names provided as input.
    `ExtractorFactory<?>` | `getFactory​(String name)` | Retrieves a `ExtractorFactory` given its name
    `boolean` | `isRegisteredName​(String name)` |
    `void` | `register​(ExtractorFactory<?> factory)` | Registers an `ExtractorFactory`.
    `void` | `unregister​(String name)` |

- - ### Method Detail

    - #### register

          void register​(ExtractorFactory<?> factory)

      Registers an `ExtractorFactory`.
      Parameters:
        `factory` - an `ExtractorFactory` to register.
      Throws:
        `IllegalArgumentException` - if trying to register a `ExtractorFactory` that already exists in the registry.

    - #### getFactory

          ExtractorFactory<?> getFactory​(String name)

      Retrieves a `ExtractorFactory` given its name
      Parameters:
        `name` - The name of the desired factory
      Returns:
        The `ExtractorFactory` associated to the provided name
      Throws:
        `IllegalArgumentException` - If there is not an `ExtractorFactory` associated to the provided name.

    - #### getExtractorGroup

          ExtractorGroup getExtractorGroup()

      Returns:
        An `ExtractorGroup` with all the registered `Extractor`.

    - #### getExtractorGroup

          ExtractorGroup getExtractorGroup​(List<String> names)

      Returns an `ExtractorGroup` containing the `ExtractorFactory` mathing the names provided as input.
      Parameters:
        `names` - A `List` containing the names of the desired `ExtractorFactory`.
      Returns:
        the extraction group.

    - #### isRegisteredName

          boolean isRegisteredName​(String name)

      Parameters:
        `name` - The name of the `ExtractorFactory`
      Returns:
        `true` if is there a `ExtractorFactory` associated to the provided name.

    - #### getAllNames

          List<String> getAllNames()

      Returns the names of all registered extractors, sorted alphabetically.
      Returns:
        an alphabetically sorted `List`

    - #### unregister

          void unregister​(String name)